﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
//using System.Threading.Tasks;
using System.Windows.Forms;

namespace testmultitermitf
{
    public partial class fName : Form
    {
        public fName()
        {
            InitializeComponent();
        }
        private void AppendLog(string msg)
        {
            eLog.AppendText(msg + "\r\n");
        }
        private void tryOpen(MultiTermIX.TermbaseRepository localRepo, string name)
        {
            try
            {
                MultiTermIX.Termbase tbExists = localRepo.Termbases[name];
                if (tbExists == null)
                {
                    AppendLog("Error exporting to SDLTB (Termbase does not exist)");
                    return;
                }
                AppendLog("Name:" + tbExists.Name + " " + tbExists.Definition);
            }
            catch (Exception e)
            {
                AppendLog("Failed to open termbase " + name + " " + e.Message);
            }
        }
        private void exportSDLTB()
        {
            try
            {

                AppendLog("Creating object");
                //new Sdl.MultiTerm.Interop.MTTMO2.ApplicationClass();
                //Sdl.MultiTerm.Interop.MTTMO2.Application mtApp = new Sdl.MultiTerm.Interop.MTTMO2.ApplicationClass();
                MultiTermIX.Application mtApp = new MultiTermIX.Application();
                if (mtApp == null)
                {
                    AppendLog("Multiterm 2009 does not appear to be installed on this PC - Cannot export to SDLTB");
                    return;
                }
                MultiTermIX.TermbaseRepository localRepo = mtApp.LocalRepository;
                if (localRepo == null)
                {
                    AppendLog("Error exporting to SDLTB: Cannot create local multiterm repository - Is Multiterm 2009 desktop installed on this PC");
                    return;
                }
                localRepo.Connect("", "");
                AppendLog("Connection status to local repository:" + localRepo.IsConnected);
                MultiTermIX.Termbases termbases = localRepo.Termbases;
                if (termbases == null)
                {
                    AppendLog("Error exporting to SDLTB (Termbases)- Is Multiterm 2009 desktop installed on this PC");
                    return;
                }
                tryOpen(localRepo, "test_JA");
                tryOpen(localRepo, "test_NL");
                tryOpen(localRepo, "t1");
                tryOpen(localRepo, "test.xdt");
                tryOpen(localRepo, "fvTermbase.sdltb");
                //Sdl.MultiTerm.Interop.MTTMO2.Termbase tb;
                AppendLog("There are " + termbases.Count + " termbases in the local repo.");
                foreach (MultiTermIX.Termbase tb in termbases)
                {
                    AppendLog("Name:" + tb.Name + " " + tb.Definition);
                }
                try
                {
                    termbases.Add("e:\\t3.sdltb", "t3", "t3");
                    MultiTermIX.Termbase tbNew = termbases["t3"];
                    if (tbNew == null)
                    {
                        MessageBox.Show("Error exporting to SDLTB (New Termbase)- Is Multiterm 2009 desktop installed on this PC");
                        return;
                    }
                }
                catch (System.Runtime.InteropServices.COMException comex)
                {
                    AppendLog("Failed to Add new termbase " + comex.Message + " code:" + comex.ErrorCode);
                }
                catch (Exception ex)
                {
                    AppendLog("Failed to Add new termbase " + ex.Message);
                }
                try
                {
                    MultiTermIX.Termbase tbNew = termbases.New("test_JA", "test_JA", "e:\\testfv.xdt", "e:\\");
                    if (tbNew == null)
                    {
                        MessageBox.Show("Error exporting to SDLTB (New Termbase)- Is Multiterm 2009 desktop installed on this PC");
                        return;
                    }
                }
                catch (Exception ex)
                {
                    AppendLog("Failed to create new termbase " + ex.Message);
                }
                //AppendLog("Termbase created successfully.");
            }
            catch (Exception ex)
            {
                AppendLog("Failed to connect to Multiterm " + ex.Message);
            }
        }
        private void btConnect_Click(object sender, EventArgs e)
        {
            exportSDLTB();
        }
    }
}
